--
--
--

loadfile("luaScripts/screen_reader_common.inc")();
loadfile("luaScripts/ui_utils.inc")();

per_click_delay = 10;

last = 0;

spirits = {
"placeholder", "RockSpirits.png", "WoodSpirits.png", "WormSpirits.png", "GrainSpirits.png", "VegetableSpirits.png",
"MineralSpirits.png", "FishSpirits.png", "GreySpirits.png"};

function clickAll(image_name, up)
	if nil then
		lsPrintln("Would click '".. image_name .. "'");
		return; -- not clicking buttons for debugging
	end
	-- Find buttons and click them!
	srReadScreen();
	xyWindowSize = srGetWindowSize();
	local buttons = findAllImages(image_name);
	
	if #buttons == 0 then
		statusScreen("Could not find specified buttons...");
		lsSleep(1500);
	else
		statusScreen("Clicking " .. #buttons .. "button(s)...");
		if up then
			for i=#buttons, 1, -1  do
				srClickMouseNoMove(buttons[i][0]+5, buttons[i][1]+3);
				lsSleep(per_click_delay);
			end
		else
			for i=1, #buttons  do
				srClickMouseNoMove(buttons[i][0]+5, buttons[i][1]+3);
				lsSleep(per_click_delay);
			end
		end
		statusScreen("Done clicking (" .. #buttons .. " clicks).");
		lsSleep(50);
	end
end

function clickOnce(image_name)
	-- Find buttons and click them!
	srReadScreen();
--	xyWindowSize = srGetWindowSize();
	local buttons = findAllImages("Chem/" .. image_name);
		
	if #buttons == 0 then
		statusScreen("Searching for " .. image_name);
		return false;
	else
		statusScreen("Clicking " .. #buttons .. "button(s)...");
		srClickMouseNoMove(buttons[1][0]+5, buttons[1][1]+3);
		statusScreen("Done clicking.");
		lsSleep(500);
		return true;
	end
end

function clickOnceReq(image_name)
	local numErr = 0;
	while (numErr < 5 and not clickOnce(image_name)) == true do
		numErr = numErr+1;
		lsSleep(1000);
	end
	if (numErr == 15) then
		error ("Could not find Chem/" .. image_name);
	end
end


function runEssence()
	--find first essence and click
	clickAll("Chem/ChemLab.png");
	lsSleep(50);
	if clickOnce("Manufacture.png") == false then
		return false;
	end
	lsSleep(50);
	if clickOnce("EssentialDistillation.png") == false then
		return false;
	end
	lsSleep(50);
	clickOnceReq("PlaceEssence.png");
	local found = false;
	local index = 0;
	--Search 5 times for Find the essence to be loaded
	for i = 0, 5, 1 do
		lsSleep(50);
		if found then
			break
		end 
		for j = 0, (#essences/9) - 1, 1 do
			local cur = (last+j)%(#essences/9)
			found = clickOnce(essences[(9*cur)+1]);
			if found then
				index = cur;
				last = cur;
				break
			end
		end
	end
	if not found then
		error "Could not find Essence";
	end
	lsSleep(50);
	clickOnceReq("Ok.png");
	
	--add the alcohols
	
	local test = "";
	local count = 0;	
	for i = 1, 8, 1 do
		local cur = essences[9*index + i+1];
		if cur ~= 0 then
			lsSleep(250);
			clickOnceReq("Manufacture.png");
			clickOnceReq("AlcoholLamp.png");
			clickOnceReq("FillAlch.png");
			clickOnceReq(spirits[i+1]);
			lsSleep(50);
			srKeyEvent(cur .. "\n");
			lsSleep(250);
			count = count+1;
		end
		test = test .. cur;
	end
	if (count == 1) then
		lsSleep(750);
	end
	lsSleep(250);
		
	--alcohol added, now start the distillation
	clickOnceReq("Manufacture.png");
	clickOnceReq("EssentialDistillation.png");
	clickOnceReq("StartEssential.png");
	
	return true;
end
	
	--Search through all essences
function doit()
	askForWindow("Pin any number of Chemistry Labs, ensure you have at least one of the following spirits:"..
	              "Fish, Grain, Grey, Mineral, Rock, Vegetable, Wood, Worm, and stash all inventory except Essential material & spirits.".. 
			"Keyboard entry is not recommended while macro is loading spirits");
	while (1) do
		runEssence();
		lsSleep(100);
	end
end